from script.calculation import Calculate
import tkinter as tk
from tkinter import filedialog

root = tk.Tk()
root.withdraw()

class Main():
    def __init__(self):
        self.calc = Calculate()
        pass
    
    def printmenu(self):
        print()
        print('\n','-' * 36)
        print('#' * 15 + ' CALCULATIONS MENU ' + '#' * 15)
        print('0-) Exit')
        #print('1-) Select directories')
        print('1-) Run Step-2 (one file)')
        print('2-) Run Batch (one file)')
        print('3-) Run Step-2 (all files)')
        print('4-) Run Batch (all files)')
        print('5-) Merge files from selection')
        print('6-) All-in-one, select batch directory')
        print()
    
    def printloc(self):
        print()
        print('#' * 15 + ' Directories ' + '#' * 15)
        print('Step2 inputs dir: ', self.calc.dir_step2)
        print('Batch inputs dir: ', self.calc.dir_batch)
        print('Outputs dir: ', self.calc.out_folder)
        print()
        print('\n','-' * 36)
        print('#' * 15 + ' OPTIONS MENU ' + '#' * 15)
        print('0-) Back')
        print('1-) Select Step2 input directory')
        print('2-) Select Batch input directory')
        print('3-) Select output directory')
        print()
    
    def menu(self):
        
        while True:
            self.printmenu()
            choice = input('Please select item from menu: ')
            ftypes = [("Excel file", ".xlsx .xls .csv")]
            
            if choice == '0':
                break
            elif choice == '1':
                file_path = filedialog.askopenfilename(filetypes=ftypes)
                if file_path is not None and len(file_path) > 0:
                    self.calc.runs2(file_path)
            elif choice == '2':
                file_path = filedialog.askopenfilename(filetypes=ftypes)
                if file_path is not None and len(file_path) > 0:
                    self.calc.runbatch(file_path)
            elif choice == '3':
                file_path = filedialog.askdirectory() 
                if file_path is not None and len(file_path) > 0:
                    file_path = file_path + '/'
                    self.calc.step2fileread(file_path)
                    self.calc.runalls2()
            elif choice == '4':
                file_path = filedialog.askdirectory() 
                if file_path is not None and len(file_path) > 0:
                    file_path = file_path + '/'
                    self.calc.batchfileread(file_path)
                    self.calc.runallbatch()
            elif choice == '5':
                BATCH_DIR = filedialog.askdirectory()
                # check if director is empty?
                if BATCH_DIR is None or len(BATCH_DIR) == 0:
                    print('No directory selected')
                    continue
                self.calc.mergefiles(BATCH_DIR)
            elif choice == '6':
                BATCH_DIR = filedialog.askdirectory()
                # check if director is empty?
                if BATCH_DIR is None or len(BATCH_DIR) == 0:
                    print('No directory selected')
                    continue
                self.calc.allinone(BATCH_DIR)


    def run(self):
        self.menu()

if __name__ == '__main__':
    main = Main()
    main.run()
        